Merge branch 'credentials' of git+ssh://gnunet.org/gnunet into credentials
[oweals/gnunet.git] / src / gns / test_gns_nick_shorten.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_gns_nick_shorten.conf" SIGINT
3 which timeout &> /dev/null && DO_TIMEOUT="timeout 5"
4
5 # This test tests shortening functionality based on NICK records:
6 #
7 # zone "delegatedego": Alice's zone
8 # zone "testego": Local zone with delegation to alice
9
10 LOCATION=$(which gnunet-config)
11 if [ -z $LOCATION ]
12 then
13   LOCATION="gnunet-config"
14 fi
15 $LOCATION --version 1> /dev/null
16 if test $? != 0
17 then
18         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
19         exit 77
20 fi
21
22 # Deleting home directory from previous runs
23 TEST_CONFIG="test_gns_nick_shorten.conf "
24 rm -rf /tmp/test-gnunet-gns-peer-1/
25 TEST_IP="127.0.0.1"
26 TEST_IP="127.0.0.2"
27 TEST_NICK_EGO="ego"
28 TEST_NICK_DELEGATED="alice"
29 TEST_NAME="www.mybestfriendalice.gnu"
30 TEST_NAME_SHORT="www.alice.short.gnu"
31
32 # export GNUNET_FORCE_LOG="namestore;;;;DEBUG/gns;;;;DEBUG/;;;;WARNING"
33
34 # Start gnunet
35 echo "Starting arm with configuration $TEST_CONFIG"
36 gnunet-arm -s -c $TEST_CONFIG
37
38 # Create initial identities: short-zone, delegated-zone, testego
39 echo "Creating identities"
40 gnunet-identity -d -c $TEST_CONFIG
41 gnunet-identity -C short-zone -c $TEST_CONFIG
42 gnunet-identity -C delegatedego -c $TEST_CONFIG
43 gnunet-identity -e short-zone -s gns-short -c $TEST_CONFIG
44 gnunet-identity -C testego -c $TEST_CONFIG
45
46 echo "Adding nick names for identities"
47 gnunet-namestore -z testego -i $TEST_NICK_EGO -c $TEST_CONFIG
48 gnunet-namestore -z delegatedego -i $TEST_NICK_DELEGATED -c $TEST_CONFIG
49
50 # Adding label www in Alice's delegatedego zone
51 echo "Adding www record with IP $TEST_IP"
52 gnunet-namestore -p -z delegatedego -a -n www -t A -V $TEST_IP -e never -c test_gns_nick_shorten.conf
53
54 # Retrieve PKEYs for delegation
55 DELEGATED_PKEY=$(gnunet-identity -d -c $TEST_CONFIG| grep delegatedego | awk '{print $3}')
56 echo "Alice's PKEY is $DELEGATED_PKEY"
57
58 SHORTEN_PKEY=$(gnunet-identity -c test_gns_nick_shorten.conf -d | grep short-zone | awk '{print $3}')
59 echo "Shorten PKEY is $SHORTEN_PKEY"
60
61 # Delegate the name "short" to shortenzone
62 gnunet-namestore -p -z testego -a -n short -t PKEY -V $SHORTEN_PKEY -e never -c test_gns_nick_shorten.conf
63
64 # Delegate the name "mybestfriendalice" to alice
65 gnunet-namestore -p -z testego -a -n mybestfriendalice -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_nick_shorten.conf
66
67 # Perform lookup to shorten
68 echo "Start gns..."
69 gnunet-arm -c test_gns_nick_shorten.conf -i gns
70
71
72 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -z testego -u $TEST_NAME -t A -c test_gns_nick_shorten.conf`
73
74 sleep 1
75
76 echo "Lookup shortened names"
77 PKEY_SHORT_RES=$($DO_TIMEOUT gnunet-gns --raw -c test_gns_nick_shorten.conf -z short-zone -u alice.gnu -t PKEY)
78 echo "Resolving alice's PKEY in shorten zone: $PKEY_SHORT_RES"
79 PKEY_RES=$($DO_TIMEOUT gnunet-gns --raw -c test_gns_nick_shorten.conf -z testego -u alice.short.gnu -t PKEY)
80 echo "Resolving alice's PKEY in master zone: $PKEY_RES"
81
82 RES=0
83 if [ "$DELEGATED_PKEY" == "$PKEY_SHORT_RES" ]
84 then
85   echo "PASS: Resolved delegation for shorten name in shortened zone"
86 else
87   echo "FAIL: Expected PKEY in $DELEGATED_PKEY, received PKEY '$PKEY_SHORT_RES' in shorten zone."
88   RES=1
89 fi
90
91 if [ "$DELEGATED_PKEY" == "$PKEY_RES" ]
92 then
93   echo "PASS: Resolved delegation for shorten name in master zone"
94 else
95   echo "FAIL: Expected PKEY in $DELEGATED_PKEY, received PKEY $PKEY_SHORT_RES in master zone."
96   RES=1
97 fi
98
99 if [ $RES -eq 0 ]
100 then
101         RES_IP=`$DO_TIMEOUT gnunet-gns --raw -z testego -u $TEST_NAME_SHORT -t A -c test_gns_nick_shorten.conf`
102         if [ "$RES_IP" == "$TEST_IP" ]
103         then
104                 echo "PASS: Received $TEST_IP for $TEST_NAME_SHORT"
105         else
106                 echo "FAIL: Expected IP in $TEST_IP, received IP '$RES_IP' for $TEST_SHORT_NAME."
107                 RES=1
108         fi
109 fi
110
111
112 # Clean up
113 echo "Clean up..."
114 gnunet-namestore -z testego -d -n mybestfriendalice -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_nick_shorten.conf
115 gnunet-namestore -z delegatedego -d -n www -t A -V $TEST_IP  -e never -c test_gns_nick_shorten.conf
116 gnunet-identity -D -z testego -c $TEST_CONFIG
117 gnunet-identity -D -z delegatedego -c $TEST_CONFIG
118 gnunet-identity -D -z short-zone -c $TEST_CONFIG
119
120 gnunet-arm -e -c test_gns_nick_shorten.conf
121 rm -rf /tmp/test-gnunet-gns-peer-1/
122
123 exit $RES
124